	.module teethtime.c
	.area lit(rom, con, rel)
_rev::
	.byte 16
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbsym e rev _rev kc
	.area vector(rom, abs)
	.org 8
	rjmp _timer
	.area lit(rom, con, rel)
	.area vector(rom, abs)
	.org 2
	rjmp _button
	.area lit(rom, con, rel)
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
_period::
	.blkb 1
	.area idata
	.byte 16
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbsym e period _period c
_pitch::
	.blkb 1
	.area idata
	.byte 3
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbsym e pitch _pitch c
_tempo::
	.blkb 1
	.area idata
	.byte 8
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbsym e tempo _tempo c
	.area lit(rom, con, rel)
_scale::
	.byte 240,226
	.byte 216,200
	.byte 192,180
	.byte 169,160
	.byte 150,144
	.byte 135,128
	.byte 'x,'q
	.byte 'l,'d
	.byte 96,'Z
	.byte 'T,'P
	.byte 'K,'H
	.byte 'C,64
	.byte 60
	.dbsym e scale _scale A[25:25]kc
_song0::
	.byte 50,'E,52,45,'e,52,45,'d,'b,49,45,'c,49,'d,'e,45
	.byte 'E,52,45,'c,52,'b,56,45,'j,'C,52,'a,52,45,'G,'E
	.byte 49,45,'F,49,'G,'a,45,'F,'D,49,'E,49,45,'F,'G,'E
	.byte 52,45,0
	.dbsym e song0 _song0 A[51:51]kc
_song1::
	.byte 50,'A,'E,49,'i,'E,49,'i,'E,'j,'E,49,'i,'E,49,'i
	.byte 'E,'j,'E,'j,'F,51,'E,49,'D,52,'j,'D,'j,'D,'j,'E
	.byte 'D,'C,'D,51,'C,49,'B,'A,35,'B,'E,54,0
	.dbsym e song1 _song1 A[45:45]kc
_song2::
	.byte 50,'D,52,'j,'D,'a,'j,'a,'j,'a,'E,51,'F,49,'E,'D
	.byte 54,'n,'a,'c,'d,52,'c,'a,'b,'G,'a,52,0
	.dbsym e song2 _song2 A[29:29]kc
_song3::
	.byte 49,'e,'d,'b,52,'d,50,'G,51,'j,'G,'E,'D,51,'G,'j
	.byte 'G,'j,'G,'j,'G,'j,'b,'j,'b,'j,'a,50,'G,54,0
	.dbsym e song3 _song3 A[31:31]kc
_song4::
	.byte 50,'G,'E,'G,51,'j,'G,'E,'G,51,'j,'G,'E,'G,51,'a
	.byte 49,'G,'E,'G,52,'j,'E,'F,'G,'F,52,'D,'G,'F,52,'D
	.byte 'C,54,0
	.dbsym e song4 _song4 A[35:35]kc
_song5::
	.byte 49,'C,'E,'F,'G,51,'j,'C,'E,'F,'G,51,'j,'C,'E,'F
	.byte 'G,50,'E,50,'C,50,'E,50,'D,54,0
	.dbsym e song5 _song5 A[27:27]kc
_song6::
	.byte 50,'C,'j,'C,'E,'G,'c,54,'a,56,'m,'a,'F,'G,'a,'G
	.byte 57,'m,'C,'C,'E,'G,'j,'G,54,'D,57,'m,'E,'F,'E,'D
	.byte 'C,56,0
	.dbsym e song6 _song6 A[35:35]kc
_song7::
	.byte 50,'D,'G,'b,45,'a,49,'G,49,'F,35,'a,'G,54,'D,54
	.byte 'j,'D,'G,'b,45,'a,49,'G,49,'F,35,'a,'G,54,0
	.dbsym e song7 _song7 A[31:31]kc
_song8::
	.byte 49,'G,'F,35,'G,'a,'G,'m,'a,'m,'b,'a,'b,'c,'b,'m
	.byte 'c,'m,'d,50,'G,'c,'b,'m,'a,'m,'G,54,0
	.dbsym e song8 _song8 A[29:29]kc
_song9::
	.byte 49,'d,50,'c,50,35,'d,50,'e,50,'c,50,'b,50,'c,50
	.byte 'd,50,'b,'d,'g,'f,35,'e,'d,'c,'b,'a,50,'o,'D,54
	.byte 'E,50,'C,54,'D,50,'B,'m,'D,'m,'E,'m,'F,35,'m,'G
	.byte 50,0
	.dbsym e song9 _song9 A[50:50]kc
_songA::
	.byte 49,'g,52,'f,'e,'d,'c,'g,52,'f,'e,'d,'c,'E,'F,'G
	.byte 'm,'F,'m,'E,'m,'D,50,'G,'m,'E,'m,'C,'m,'g,52,'f
	.byte 'e,'d,'c,'g,52,'f,'e,'d,'c,'E,'F,'G,'m,'F,'m,'E
	.byte 'm,'D,50,'G,'m,'C,52,0
	.dbsym e songA _songA A[56:56]kc
_songB::
	.byte 52,'d,'k,'e,'k,'c,'k,'C,'k,'G,0
	.dbsym e songB _songB A[11:11]kc
_songC::
	.byte 49,'C,'D,'E,'F,'G,'a,'b,'c,0
	.dbsym e songC _songC A[10:10]kc
_songD::
	.byte 50,'C,'E,'G,'c,0
	.dbsym e songD _songD A[6:6]kc
_songE::
	.byte 49,'a,'l,'a,0
	.dbsym e songE _songE A[5:5]kc
_songF::
	.byte 49,'c,0
	.dbsym e songF _songF A[3:3]kc
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
_songN::
	.blkw 1
	.area idata
	.word _song0
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song1
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song2
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song3
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song4
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song5
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song6
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song7
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song8
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _song9
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songA
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songB
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songC
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songD
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songE
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.blkw 1
	.area idata
	.word _songF
	.area data(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbsym e songN _songN A[32:16]pkc
	.area lit(rom, con, rel)
_sc::
	.byte 1,3
	.byte 4,6
	.byte 8,9
	.byte 11,13
	.byte 15,16
	.byte 18,20
	.byte 21,23
	.dbsym e sc _sc A[14:14]kc
	.area text(rom, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
	.dbfunc e main _main fV
;              p -> R10,R11
;              a -> R12
	.even
_main::
	.dbline -1
	.dbline 82
; // teethtime.c
; 
; const char rev=0x10;  // rev 1.0 (01-Jan-05)
; 
; #include <iot2313v.h>
; #pragma interrupt_handler timer:iv_TIMER1_COMPA
; #pragma interrupt_handler button:iv_INT0
; #pragma global_register led:20 limit:21 j:22 k:23
; 
; typedef unsigned char uchar;
; typedef unsigned char bool;
; typedef unsigned int  uint;
; #define BIT(x) (1<<(x))
; #define InterruptEnable 0x80
; #define clk1024 5        // prescaler mode = clk/1024
; #define SpeakerOFF 0x40  // Speaker on PD6
; #define Pullup 0x04      // for pushbutton (PD2)
; #define NPAR 8  // number of user parameters
;                    // 0: limit (high nibble)
;                    // 1: limit (low nibble)
;                    // 2: period (high nibble)
;                    // 3: period (low nibble)
;                    // 4: bcd
;                    // 5: pitch
;                    // 6: tempo
;                    // 7: song
; #define NEXIT 4 // number of exit codes
;                    // 8:  exit and save(0)
;                    // 9:  exit and save(1)
;                    // 10: exit and recall(0)
;                    // 11: exit and recall(1)
; #define SetupCode 1 // To go to setup, press button after the 1st count
; 
; // Global variables ---------------------------------
; uchar go;
; uchar isong;
; uchar pressed;
; uchar beepon;
; uchar led;
; uchar j,k;
;                  // User parameters ---------------
; uchar limit;     // max count
; uchar period=16; // increment every second (units = 1/16 sec)
; uchar bcd;       // 0/1 Binary up/down.  2/3 BCD up/down. Default = 0 = binary/up
; uchar pitch=3;   // default pitch (smaller numbers for higher pitch)
; uchar tempo=8;   // default tempo (smaller numbers for faster temo)
; uchar song;      // default ring tone (0 does a 16 way rotate)
; 
; //                      0    1    2    3    4    5    6    7    8    9    10   11   12   13   14   15  16  17  18  19  20  21  22  23  24
; // #/- = sharp/flat     A-   A    B-   B    C    C#   D    E-   E    F    F#   G    G#   a    a#   b   c   c#  d   d#  e   f   f#  g   g# 
; const uchar scale[] = {240, 226, 216, 200, 192, 180, 169, 160, 150, 144, 135, 128, 120, 113, 108, 100, 96, 90, 84, 80, 75, 72, 67, 64, 60 };
;                    // rest identifier:  h     i     j    k    l   m n o
;                    // duration:        1/32  1/16  1/8  1/4  1/2  1 2 4
; const char song0[] = "2E4-e4-db1-c1de-E4-c4b8-jC4a4-GE1-F1Ga-FD1E1-FGE4-"; // Over the Rainbow
; const char song1[] = "2AE1iE1iEjE1iE1iEjEjF3E1D4jDjDjEDCD3C1BA#BE6";       // Chim Chim Cher-ee
; const char song2[] = "2D4jDajajaE3F1ED6nacd4cabGa4";       // Scarborough Fair
; const char song3[] = "1edb4d2G3jGED3GjGjGjGjbjbja2G6";     // Swing Low
; const char song4[] = "2GEG3jGEG3jGEG3a1GEG4jEFGF4DGF4DC6"; // The Caissons go Rolling
; const char song5[] = "1CEFG3jCEFG3jCEFG2E2C2E2D6";         // When the Saints
; const char song6[] = "2CjCEGc6a8maFGaG9mCCEGjG6D9mEFEDC8"; // On Top of Old Smoky
; const char song7[] = "2DGb-a1G1F#aG6D6jDGb-a1G1F#aG6";     // Sunrise, Sunset
; const char song8[] = "1GF#GaGmambabcbmcmd2GcbmamG6";       // Jacques Saint-Luc: The Lute Player
; const char song9[] = "1d2c2#d2e2c2b2c2d2bdgf#edcba2oD6E2C6D2BmDmEmF#mG2";       // Haslinger Sonatina
; const char songA[] = "1g4fedcg4fedcEFGmFmEmD2GmEmCmg4fedcg4fedcEFGmFmEmD2GmC4"; // Bach Musette in D major
; const char songB[] = "4dkekckCkG";   // Close Encounters 3rd kind
; const char songC[] = "1CDEFGabc";    // Major scale
; const char songD[] = "2CEGc";        // Major arpeggio
; const char songE[] = "1ala";         // Two beeps
; const char songF[] = "1c";           // One beep
; const char *songN[] = {song0, song1, song2, song3, song4, song5, song6, song7, song8, song9, songA, songB, songC, songD, songE, songF};
; //                      A  B  C  D  E  F  G   a   b   c   d   e   f   g
; const char sc[]     = { 1, 3, 4, 6, 8, 9, 11, 13, 15, 16, 18, 20, 21, 23};
; // ---------------------------------------------------
; 
; void beep(uchar freq, uint duration);
; void delayMS(uchar msec);
; uint mulj(uint a);
; uchar EEPROMread(char adr);
; int EEPROMwrite(char adr, uchar byte);
; 
; void main()
; { const char *p; // points to currently played note of ring tone
	.dbline 84
;   uchar a;       // default note duration
;   limit = 120;   // default limit = 120 seconds
	ldi R21,120
	.dbline 86
;   // Set up hardware ------------------------------------
;   DDRB = 0xFF;  // Port B drive the LEDs (outputs)
	ldi R24,255
	out 0x17,R24
	.dbline 87
;   DDRD = 0xFB;  // Set PORTD to all outputs except PD2 (button)
	ldi R24,251
	out 0x11,R24
	.dbline 88
;   PORTD = SpeakerOFF + Pullup; // turn speaker off; pullup for button
	ldi R24,68
	out 0x12,R24
	.dbline 89
;   beepon = SpeakerOFF;      // enable speaker (despite appearances:)
	ldi R24,64
	sts _beepon,R24
	.dbline 90
;   MCUCR = BIT(SE)+BIT(SM0); // Sleep Enable, Sleep Mode = power down
	ldi R24,48
	out 0x35,R24
	.dbline 91
;   TIMSK = BIT(OCIE1A);      // Output Compare Interrupt Enable A
	ldi R24,64
	out 0x39,R24
	.dbline 92
;   GIMSK = BIT(INT0);        // Enable INT0 interrupt
	out 0x3b,R24
	.dbline 93
;   SREG |= InterruptEnable;  // Global interrupt enable
	bset 7
	rjmp L3
L2:
	.dbline 95
;   while(1) // Main Loop ------------- Forever -----------------------------
;   { go = 0;                        // disable counting
	.dbline 95
	clr R2
	sts _go,R2
	.dbline 96
;     j=250; OCR1A = mulj(period);   // Compare A = 4096MHz/(1024*250*period)
	ldi R22,250
	.dbline 96
	lds R16,_period
	clr R17
	rcall _mulj
	out 0x2b,R17
	out 0x2a,R16
	.dbline 97
;     led=pressed=TCNT1H=TCNT1L=0;   // zero led count, button flag, Timer1
	clr R2
	out 0x2c,R2
	out 0x2d,R2
	sts _pressed,R2
	clr R20
	.dbline 98
;     TCCR1B = BIT(WGM12)+clk1024;   // Start Timer1, WGM12=Clear Timer on Compare
	ldi R24,13
	out 0x2e,R24
L5:
	.dbline 99
;     do { a = j = led;
	.dbline 99
	mov R22,R20
	mov R12,R20
	.dbline 100
;          if (bcd&1)                           // here for down counting
	lds R2,_bcd
	sbrs R2,0
	rjmp L8
	.dbline 101
;          { j = limit - j;                     // display time remaining
	.dbline 101
	mov R2,R21
	sub R2,R20
	mov R22,R2
	.dbline 102
;            if ((bcd>1) && ((j&15)>9)) j-= 6;  // bcd correction
	ldi R24,1
	lds R2,_bcd
	cp R24,R2
	brsh L10
	ldi R24,9
	mov R25,R22
	andi R25,15
	cp R24,R25
	brsh L10
	.dbline 102
	subi R22,6
L10:
	.dbline 103
;          }
L8:
	.dbline 104
;          PORTB = ~j;               // drive leds
	mov R2,R22
	com R2
	out 0x18,R2
	.dbline 105
;        }
L6:
	.dbline 106
;        while (a!=limit);           // wait for limit while updating LEDs
	cp R12,R21
	brne L5
	.dbline 107
;     if (!pressed)                  // Play the song when the limit is reached
	lds R2,_pressed
	tst R2
	breq X1
	rjmp L12
X1:
	.dbline 108
;     { led = song;                  // get song parameter
	.dbline 108
	lds R20,_song
	.dbline 109
;       if (!led) { led = isong; isong = 15 & (isong+1); }  // here for song rotate mode
	tst R20
	brne L14
	.dbline 109
	.dbline 109
	lds R20,_isong
	.dbline 109
	mov R24,R20
	subi R24,255    ; addi 1
	andi R24,15
	sts _isong,R24
	.dbline 109
L14:
	.dbline 110
;       p = songN[led];              // point to selected song
	ldi R24,<_songN
	ldi R25,>_songN
	mov R30,R20
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R10,z+0
	ldd R11,z+1
	.dbline 111
;       a = *p++ - '0';              // first character is default duration
	mov R2,R10
	mov R3,R11
	mov R24,R2
	mov R25,R3
	adiw R24,1
	mov R10,R24
	mov R11,R25
	mov R30,R2
	mov R31,R3
	lpm
	mov R24,R0
	subi R24,48
	mov R12,R24
	rjmp L17
L16:
	.dbline 113
;       while (k=*p++)               // process the rest of the song
;       { if (pressed) break;        // the button aborts the song
	.dbline 113
	lds R2,_pressed
	tst R2
	breq L19
	.dbline 113
	rjmp L18
L19:
	.dbline 114
;         k-='A'; if (k>6) k-=25;    // lower case a-g are an octave higher than A-G
	subi R23,65
	.dbline 114
	ldi R24,6
	cp R24,R23
	brsh L21
	.dbline 114
	subi R23,25
L21:
	.dbline 115
;         if ((j=k-sizeof(sc))<8) { beepon=0; beep(225,2<<j); beepon=SpeakerOFF; }  // rests
	mov R24,R23
	subi R24,14
	mov R22,R24
	cpi R22,8
	brsh L23
	.dbline 115
	.dbline 115
	clr R2
	sts _beepon,R2
	.dbline 115
	mov R18,R24
	clr R19
	ldi R16,2
	ldi R17,0
	rcall lsl16
	mov R18,R16
	mov R19,R17
	ldi R16,225
	rcall _beep
	.dbline 115
	ldi R24,64
	sts _beepon,R24
	.dbline 115
	rjmp L24
L23:
	.dbline 117
;         else  // if not a rest, play the note ---
;         { k = sc[k]; // get index to scale[] without taking account of sharps/flats
	.dbline 117
	ldi R24,<_sc
	ldi R25,>_sc
	mov R2,R23
	clr R3
	add R2,R24
	adc R3,R25
	mov R30,R2
	mov R31,R3
	lpm
	mov R23,R0
	.dbline 118
;           led = *p;  j = a;                          // j will be the note duration
	mov R30,R10
	mov R31,R11
	lpm
	mov R20,R0
	.dbline 118
	mov R22,R12
	.dbline 119
;           if ((led>='1') && (led<='9'))              // duration code first
	cpi R20,49
	brlo L25
	ldi R24,57
	cp R24,R0
	brlo L25
	.dbline 120
;           { j = led-'0'; led = *++p; }
	.dbline 120
	mov R22,R20
	subi R22,48
	.dbline 120
	mov R24,R10
	mov R25,R11
	adiw R24,1
	mov R10,R24
	mov R11,R25
	mov R30,R24
	mov R31,R25
	lpm
	mov R20,R0
	.dbline 120
L25:
	.dbline 121
;           if      (led=='#') { k++; goto incp; }     // then accidental codes
	cpi R20,35
	brne L27
	.dbline 121
	.dbline 121
	inc R23
	.dbline 121
	rjmp L29
L27:
	.dbline 122
	cpi R20,45
	brne L30
	.dbline 122
	.dbline 122
	dec R23
L29:
	.dbline 122
;           else if (led=='-') { k--; incp: ++p; }
	mov R24,R10
	mov R25,R11
	adiw R24,1
	mov R10,R24
	mov R11,R25
	.dbline 122
L30:
	.dbline 123
;           led=scale[24-k]; beep(scale[k],mulj(led)); // play the note
	mov R2,R23
	clr R3
	ldi R24,24
	ldi R25,0
	sub R24,R2
	sbc R25,R3
	ldi R30,<_scale
	ldi R31,>_scale
	add R24,R30
	adc R25,R31
	mov R30,R24
	mov R31,R25
	lpm
	mov R20,R0
	.dbline 123
	mov R16,R20
	clr R17
	rcall _mulj
	mov R18,R16
	mov R19,R17
	ldi R24,<_scale
	ldi R25,>_scale
	mov R2,R23
	clr R3
	add R2,R24
	adc R3,R25
	mov R30,R2
	mov R31,R3
	lpm
	mov R16,R0
	rcall _beep
	.dbline 124
;         }
L24:
	.dbline 125
L17:
	.dbline 112
	mov R2,R10
	mov R3,R11
	mov R24,R2
	mov R25,R3
	adiw R24,1
	mov R10,R24
	mov R11,R25
	mov R30,R2
	mov R31,R3
	lpm
	mov R23,R0
	tst R23
	breq X2
	rjmp L16
X2:
L18:
	.dbline 126
;       }
;     }
L12:
	.dbline 127
	clr R20
	.dbline 127
	ldi R24,255
	out 0x18,R24
	.dbline 128
	sleep
	.dbline 129
L3:
	.dbline 94
	rjmp L2
X0:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r p 10 pkc
	.dbsym r a 12 c
	.dbend
	.dbfunc e beep _beep fV
;              b -> <dead>
;              c -> R10
;              a -> R14
;       duration -> R12,R13
;           freq -> y+6
	.even
_beep::
	rcall push_arg4
	rcall push_gset5x
	mov R12,R18
	mov R13,R19
	.dbline -1
	.dbline 133
;     led = 0; PORTB = 0xFF; // Turn LEDs off
;     asm("sleep");          // Go to sleep
;   }
; }
; 
; void beep(uchar freq, uint duration) // play a note (or a rest)
; { uchar c = SpeakerOFF + Pullup;
	.dbline 133
	ldi R24,68
	mov R10,R24
	.dbline 135
;   uchar a,b;
;   j = tempo; duration = 0xFFFE & (mulj(duration)>>2);
	lds R22,_tempo
	.dbline 135
	mov R16,R12
	mov R17,R13
	rcall _mulj
	mov R24,R16
	mov R25,R17
	lsr R25
	ror R24
	lsr R25
	ror R24
	andi R24,254
	mov R12,R24
	mov R13,R25
	rjmp L34
L33:
	.dbline 137
	.dbline 137
	lds R2,_beepon
	mov R3,R10
	sub R3,R2
	mov R10,R3
	out 0x12,R3
	.dbline 137
	ldd R22,y+6
	rjmp L39
L36:
	.dbline 137
	lds R14,_pitch
	rjmp L43
L40:
	.dbline 137
L41:
	.dbline 137
	dec R14
L43:
	.dbline 137
	tst R14
	brne L40
L37:
	.dbline 137
	dec R22
L39:
	.dbline 137
	tst R22
	brne L36
	.dbline 137
L34:
	.dbline 136
;   while (duration--)  // note: duration must be even
	mov R2,R12
	mov R3,R13
	mov R24,R2
	mov R25,R3
	sbiw R24,1
	mov R12,R24
	mov R13,R25
	tst R2
	brne L33
	tst R3
	brne L33
X3:
	.dbline -2
L32:
	rcall pop_gset5x
	adiw R28,4
	.dbline 0 ; func end
	ret
	.dbsym l b 1 c
	.dbsym r c 10 c
	.dbsym r a 14 c
	.dbsym r duration 12 i
	.dbsym l freq 6 c
	.dbend
	.dbfunc e mulj _mulj fi
;            ans -> R10,R11
;              a -> R16,R17
	.even
_mulj::
	rcall push_gset3x
	.dbline -1
	.dbline 141
;     { PORTD = (c-=beepon); for(j=freq; j; j--) for(a=pitch; a; a--); }
; }
; 
; uint mulj(uint a)  // unsigned multiply: 8 bit j by 16 bit a
; { uint ans = 0;
	.dbline 141
	clr R10
	clr R11
	rjmp L46
L45:
	.dbline 142
	.dbline 142
	sbrs R22,0
	rjmp L48
	.dbline 142
	add R10,R16
	adc R11,R17
L48:
	.dbline 142
	lsl R16
	rol R17
	.dbline 142
	lsr R22
	.dbline 142
L46:
	.dbline 142
;   while (j) { if (j&1) ans+=a; a<<=1; j>>=1; }
	tst R22
	brne L45
	.dbline 143
;   return(ans);
	mov R16,R10
	mov R17,R11
	.dbline -2
L44:
	rcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r ans 10 i
	.dbsym r a 16 i
	.dbend
	.dbfunc e delayMS _delayMS fV
;              a -> R10,R11
;           msec -> R16
	.even
_delayMS::
	rcall push_gset3x
	.dbline -1
	.dbline 147
; }
; 
; void delayMS(uchar msec)  // delay msec milliseconds
; { uint a;
	rjmp L52
L51:
	.dbline 148
	ldi R24,453
	ldi R25,1
	mov R10,R24
	mov R11,R25
	rjmp L57
L54:
	.dbline 148
L55:
	.dbline 148
	mov R24,R10
	mov R25,R11
	sbiw R24,1
	mov R10,R24
	mov R11,R25
L57:
	.dbline 148
	tst R10
	brne L54
	tst R11
	brne L54
X4:
L52:
	.dbline 148
;   while (msec--) for (a=453; a; a--);
	mov R2,R16
	clr R3
	subi R16,1
	tst R2
	brne L51
	.dbline -2
L50:
	rcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r a 10 i
	.dbsym r msec 16 c
	.dbend
	.dbfunc e timer _timer fV
	.even
_timer::
	st -y,R2
	st -y,R24
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 152
	.dbline 152
	lds R2,_go
	add R20,R2
	.dbline 152
	ldi R24,1
	sts _go,R24
	.dbline 152
	lds R2,_bcd
	cp R24,R2
	brsh L59
	mov R24,R20
	andi R24,15
	cpi R24,10
	brne L59
	.dbline 152
	subi R20,250    ; addi 6
L59:
	.dbline -2
L58:
	ld R2,y+
	out 0x3f,R2
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e bdown _bdown fc
	.even
_bdown::
	.dbline -1
	.dbline 154
; }
; 
; void timer()     // Timer B interrupt
; { led+=go; go=1;  if ((bcd>1) && ((led&15)==10)) led += 6; }
; 
; bool bdown() { return !(PIND & Pullup); }  // returns true if button is down
	.dbline 154
	sbic 0x10,2
	rjmp L62
	ldi R16,1
	ldi R17,0
	rjmp L63
L62:
	clr R16
	clr R17
L63:
	.dbline -2
L61:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e button _button fV
;              e -> y+0
	.even
_button::
	rcall push_lset
	rcall push_gset3x
	sbiw R28,12
	.dbline -1
	.dbline 157
; 
; void button()           // INT2 interrupt (on button press)
; { uchar e[NPAR+NEXIT];  // parameters start at e[1]
	.dbline 158
;   TCCR1B = 0;           // Stop Timer1
	clr R2
	out 0x2e,R2
	.dbline 159
;   delayMS(10);          // debounce
	ldi R16,10
	rcall _delayMS
L65:
	.dbline 160
L66:
	.dbline 160
;   while (bdown());      // Wait for button release
	rcall _bdown
	tst R16
	brne L65
	.dbline 161
;   beep(led?80:120,10);  // Beep
	ldi R18,10
	ldi R19,0
	tst R20
	breq L68
	ldi R24,80
	ldi R25,0
	mov R10,R24
	mov R11,R25
	rjmp L69
L68:
	ldi R24,120
	ldi R25,0
	mov R10,R24
	mov R11,R25
L69:
	mov R16,R10
	rcall _beep
	.dbline 162
;   delayMS(10);          // Debounce
	ldi R16,10
	rcall _delayMS
	.dbline 163
;   if (led==SetupCode)
	cpi R20,1
	breq X6
	rjmp L70
X6:
	.dbline 164
;   { delayMS(200); beep(120,10);
	.dbline 164
	ldi R16,200
	rcall _delayMS
	.dbline 164
	ldi R18,10
	ldi R19,0
	ldi R16,120
	rcall _beep
	.dbline 165
;     e[0]  = limit >> 4;
	mov R24,R21
	swap R24
	andi R24,#0x0F
	std y+0,R24
	.dbline 166
;     e[1]  = limit & 15;
	mov R24,R21
	andi R24,15
	std y+1,R24
	.dbline 167
;     e[2]  = period >> 4;
	lds R24,_period
	swap R24
	andi R24,#0x0F
	std y+2,R24
	.dbline 168
;     e[3]  = period & 15;
	lds R24,_period
	andi R24,15
	std y+3,R24
	.dbline 169
;     e[4]  = bcd;
	lds R2,_bcd
	std y+4,R2
	.dbline 170
;     e[5]  = pitch;
	lds R2,_pitch
	std y+5,R2
	.dbline 171
;     e[6]  = tempo;
	lds R2,_tempo
	std y+6,R2
	.dbline 172
;     e[7]  = song;
	lds R2,_song
	std y+7,R2
	.dbline 173
;     e[8]  = 0;   // save(0) and exit setup
	clr R2
	std y+8,R2
	.dbline 174
;     e[9]  = 0;   // save(1) and exit setup
	std y+9,R2
	.dbline 175
;     e[10] = 0;   // recall(0) and exit setup
	std y+10,R2
	.dbline 176
;     e[11] = 0;   // recall(1) and exit setup
	std y+11,R2
	.dbline 177
;     k = 0; // k identifies which parameter (e[0] thru e[NPAR-1])
	clr R23
	rjmp L84
X5:
	.dbline 181
;            // is being displayed or modified or which exit code
;            // e[NPAR] thru e[NPAR+NEXIT-1] will be used.
;     while(1)     // do until the button is pushed while k is zero
;     { while(1)   // cycle thru all parameters until button is pressed
L86:
	.dbline 182
;       { PORTB = ~(k  + (e[k]<<4));  // low/high nibble is param number/value
	.dbline 182
	mov R24,R28
	mov R25,R29
	mov R30,R23
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	andi R24,#0x0F
	swap R24
	mov R2,R23
	add R2,R24
	com R2
	out 0x18,R2
	.dbline 183
;         for (led=240; led; led--)   // cycle at 1.2 sec per parameter (250*.005)
	ldi R20,240
	rjmp L92
L89:
	.dbline 184
	.dbline 184
	ldi R16,5
	rcall _delayMS
	.dbline 184
	rcall _bdown
	tst R16
	breq L93
	.dbline 184
	rjmp L95
L93:
	.dbline 184
L90:
	.dbline 183
	dec R20
L92:
	.dbline 183
	tst R20
	brne L89
	.dbline 185
;         { delayMS(5); if (bdown()) goto ma; }
;         if (++k == sizeof(e)) k=0;  // wrap from last exit code back to zero
	mov R24,R23
	subi R24,255    ; addi 1
	mov R23,R24
	cpi R23,12
	brne L96
	.dbline 185
	clr R23
L96:
	.dbline 186
L87:
	.dbline 181
	rjmp L86
L95:
	.dbline 187
;       }
;       ma: delayMS(10);           // debounce after button press
	ldi R16,10
	rcall _delayMS
L98:
	.dbline 188
L99:
	.dbline 188
;       while (bdown());           // Wait for button release
	rcall _bdown
	tst R16
	brne L98
	.dbline 189
;       beep(100,8); delayMS(50);  // beep and debounce
	ldi R18,8
	ldi R19,0
	ldi R16,100
	rcall _beep
	.dbline 189
	ldi R16,50
	rcall _delayMS
	.dbline 190
;       beep(100,8);
	ldi R18,8
	ldi R19,0
	ldi R16,100
	rcall _beep
	.dbline 191
;       if (k>=NPAR)               // handle exit codes
	cpi R23,8
	brsh X7
	rjmp L101
X7:
	.dbline 192
;         if (k>9) { limit  = EEPROMread(k=(k-10)<<3); // recall from EEprom
	ldi R24,9
	cp R24,R23
	brsh L103
	.dbline 192
	.dbline 192
	mov R24,R23
	subi R24,10
	lsl R24
	lsl R24
	lsl R24
	mov R23,R24
	mov R16,R24
	rcall _EEPROMread
	mov R21,R16
	.dbline 193
;                    period = EEPROMread(k+1);
	mov R16,R23
	subi R16,255    ; addi 1
	rcall _EEPROMread
	sts _period,R16
	.dbline 194
;                    bcd    = EEPROMread(k+2);
	mov R16,R23
	subi R16,254    ; addi 2
	rcall _EEPROMread
	sts _bcd,R16
	.dbline 195
;                    pitch  = EEPROMread(k+3);
	mov R16,R23
	subi R16,253    ; addi 3
	rcall _EEPROMread
	sts _pitch,R16
	.dbline 196
;                    tempo  = EEPROMread(k+4);
	mov R16,R23
	subi R16,252    ; addi 4
	rcall _EEPROMread
	sts _tempo,R16
	.dbline 197
;                    song   = EEPROMread(k+5);
	mov R16,R23
	subi R16,251    ; addi 5
	rcall _EEPROMread
	sts _song,R16
	.dbline 198
;                    break;                            // and exit from interrupt
	rjmp L85
L103:
	.dbline 200
;                  }
;         else     { EEPROMwrite(k=(k-8)<<3,limit = e[1] + (e[0]<<4));
	.dbline 200
	ldd R24,y+0
	andi R24,#0x0F
	swap R24
	ldd R2,y+1
	add R2,R24
	mov R21,R2
	mov R18,R2
	mov R24,R23
	subi R24,8
	lsl R24
	lsl R24
	lsl R24
	mov R23,R24
	mov R16,R24
	rcall _EEPROMwrite
	.dbline 201
;                    EEPROMwrite(k+1,period = e[3] + (e[2]<<4));
	ldd R24,y+2
	andi R24,#0x0F
	swap R24
	ldd R2,y+3
	add R2,R24
	sts _period,R2
	mov R18,R2
	mov R16,R23
	subi R16,255    ; addi 1
	rcall _EEPROMwrite
	.dbline 202
;                    EEPROMwrite(k+2,bcd = e[4]);      // save parameters in EEprom
	ldd R2,y+4
	sts _bcd,R2
	mov R18,R2
	mov R16,R23
	subi R16,254    ; addi 2
	rcall _EEPROMwrite
	.dbline 203
;                    EEPROMwrite(k+3,pitch = e[5]);
	ldd R2,y+5
	sts _pitch,R2
	mov R18,R2
	mov R16,R23
	subi R16,253    ; addi 3
	rcall _EEPROMwrite
	.dbline 204
;                    EEPROMwrite(k+4,tempo = e[6]);
	ldd R2,y+6
	sts _tempo,R2
	mov R18,R2
	mov R16,R23
	subi R16,252    ; addi 4
	rcall _EEPROMwrite
	.dbline 205
;                    EEPROMwrite(k+5,song = e[7]);
	ldd R2,y+7
	sts _song,R2
	mov R18,R2
	mov R16,R23
	subi R16,251    ; addi 5
	rcall _EEPROMwrite
	.dbline 206
;                    break;                            // and exit from interrupt
	rjmp L85
L101:
	.dbline 208
;                   }
;       limit = 0xE0; // upper nibble of limit will be the new parameter value
	ldi R21,224
	rjmp L113
L112:
	.dbline 210
;       while(1) // cycle thru the 16 possible parameter values until button push
;       { PORTB = ~(k + (limit+=16)); // low/high nibble is param number/value
	.dbline 210
	mov R24,R21
	subi R24,240    ; addi 16
	mov R21,R24
	mov R4,R23
	add R4,R24
	com R4
	out 0x18,R4
	.dbline 211
;         for (led=200; led; led--)  // cycle at .8 seconds per value (200*.004)
	ldi R20,200
	rjmp L118
L115:
	.dbline 212
	.dbline 212
	ldi R16,4
	rcall _delayMS
	.dbline 212
	rcall _bdown
	tst R16
	breq L119
	.dbline 212
	rjmp L121
L119:
	.dbline 212
L116:
	.dbline 211
	dec R20
L118:
	.dbline 211
	tst R20
	brne L115
	.dbline 213
L113:
	.dbline 209
	rjmp L112
L121:
	.dbline 214
;         { delayMS(4); if (bdown()) goto mb; }
;       }
;       mb: delayMS(10);              // debounce after button press
	ldi R16,10
	rcall _delayMS
L122:
	.dbline 215
L123:
	.dbline 215
	rcall _bdown
	tst R16
	brne L122
	.dbline 216
	ldi R18,15
	ldi R19,0
	ldi R16,80
	rcall _beep
	.dbline 216
	ldi R16,100
	rcall _delayMS
	.dbline 216
	ldi R18,15
	ldi R19,0
	ldi R16,120
	rcall _beep
	.dbline 217
	mov R2,R23
	clr R3
	subi R23,1
	mov R24,R28
	mov R25,R29
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	mov R24,R21
	swap R24
	andi R24,#0x0F
	std z+0,R24
	.dbline 218
L84:
	.dbline 180
	rjmp L87
L85:
	.dbline 219
;       while (bdown());              // Wait for button release
;       beep(80,15); delayMS(100); beep(120,15);
;       e[k--] = limit>>4; // save new parameter value
;     } // End while(1)
;   }   // End if (led==SetupCode)
L70:
	.dbline 220
;   pressed = 1; // indicate exit caused by button push
	ldi R24,1
	sts _pressed,R24
	.dbline 221
;   led = limit; // Force exit from while loop in main
	mov R20,R21
	.dbline -2
L64:
	adiw R28,12
	rcall pop_gset3x
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbsym l e 0 A[12:12]c
	.dbend
	.area bss(ram, con, rel)
	.dbfile E:\ccode\TeethTimer\teethtime.c
_song::
	.blkb 1
	.dbsym e song _song c
_bcd::
	.blkb 1
	.dbsym e bcd _bcd c
_beepon::
	.blkb 1
	.dbsym e beepon _beepon c
_pressed::
	.blkb 1
	.dbsym e pressed _pressed c
_isong::
	.blkb 1
	.dbsym e isong _isong c
_go::
	.blkb 1
	.dbsym e go _go c
